require 'virtus'

module JiraIssues
  class JiraIssue
    include Virtus.model

    attribute :key, String
    attribute :priority, String
    attribute :status, String
    attribute :type, String
    attribute :summary, String
    attribute :description, String
    attribute :assignee, String
    attribute :reporter, String
    attribute :created_date, DateTime
    attribute :closed_date, DateTime
    attribute :due_date, DateTime
    attribute :filter_status, String

    def to_json
      {
        key: issue.key,
        type: issue.issuetype.name,
        priority: issue.priority.name,
        status: status,
        description: i.description,
        summary: issue.summary,
        assignee: issue.assignee,
        reporter: issue.reporter,
        created_date: issue.created,
        closed_date: issue.resolutiondate,
      }
    end
  end
end
